diff -bruN freeswan-1.9.orig/klips/test/ipsec.funcs freeswan-1.9/klips/test/ipsec.funcs
--- freeswan-1.9.orig/klips/test/ipsec.funcs	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/klips/test/ipsec.funcs	Mon Jun  4 11:34:31 2001
@@ -0,0 +1,209 @@
+#!/bin/sh
+#
+# ipsec.func	This file contains functions for use by klips/test
+#		shell scripts.
+# Version:	0.0
+#
+# Author:	Richard Guy Briggs, <rgb@conscoop.ottawa.on.ca>
+#
+# Default search path:
+export PATH="/sbin:/usr/sbin:/usr/local/sbin:/bin:/usr/bin:/usr/local/bin"
+#
+# The following (environment) variables are expected to be set before
+# calling these functions as apropriate.
+#
+# net1=
+# net2=
+# gw1=
+# gw2=
+# h_mask=
+# n_mask=
+# ipsec_dev=
+# phys_dev=
+## iv=
+## esp_key=
+## ah_key=
+#
+# xform1a=
+# xform1b=
+# xform1c=
+# xform2a=
+# xform2b=
+# xform2c=
+#
+# spi1a=
+# spi1b=
+# spi1c=
+# spi2a=
+# spi2b=
+# spi2c=
+#
+
+# Setup module and interface
+#
+ipsec_setup() {
+	# Load the module
+	depmod -a
+	modprobe ipsec
+	# Attach and configure the interface
+	tncfg attach $ipsecdev $physdev
+	ifconfig $ipsecdev $gw1 
+}
+#
+# Clean up and unload the module
+ipsec_unload() {
+	ifconfig ipsec0 down
+	ifconfig ipsec1 down
+	rmmod ipsec
+}
+#
+# Display configuration from /proc/net/ipsec* filesystem.
+#
+ipsec_proc() {
+	echo /proc/net/ipsec-spi
+	cat /proc/net/ipsec-spi
+	echo
+	echo /proc/net/ipsec-route
+	cat /proc/net/ipsec-route
+}
+#
+# Setup a secure connection
+#
+ipsec_setconn() {
+case "$1" in
+	# Transport mode
+	trespah)
+		spi $gw1 $spi1a esp $xform1a i \
+			$iv $esp_key
+
+		route del $gw2
+		route add -host $gw2 dev ipsec0
+
+		eroute add $gw1 $hmask \
+			$gw2 $hmask \
+			$gw2 $spi2a
+		spi $gw2 $spi2a esp $xform2a i \
+			$iv $esp_key
+		;;
+	trespahdel)
+		spi $gw1 $spi1a del
+
+		spi $gw2 $spi2a del
+
+		eroute del $gw1 $hmask $gw2 $hmask
+
+		route del $gw2
+		;;
+	trah)
+		spi $gw1 $spi1a ah $xform1a $ah_key
+
+		route del $gw2
+		route add -host $gw2 dev ipsec0
+
+		eroute add $gw1 $hmask \
+			$gw2 $hmask \
+			$gw2 $spi2a
+		spi $gw2 $spi2a ah $xform2a $ah_key
+		;;
+	tresp)
+		spi $gw1 $spi1a esp $xform1a $iv $esp_key
+
+		route del $gw2
+		route add -host $gw2 dev ipsec0
+
+		eroute add $gw1 $hmask \
+			$gw2 $hmask \
+			$gw2 $spi2a
+		spi $gw2 $spi2a esp $xform2a $iv $esp_key
+		;;
+	# Tunnel mode
+	tu)
+		# return path
+		spi $gw1 $spi1b esp $xform1b $iv $esp_key
+		spi $gw1 $spi1c ah $xform1c $ah_key
+
+		route del $net2
+		route add -net $net2 dev ipsec0 gw $gw2
+
+		# forward path
+		eroute add $net1 $nmask \
+			$net2 $nmask \
+			$gw2 $spi2a
+
+		spi $gw2 $spi2a $xform2a \
+			$gw1 $gw2
+		spi $gw2 $spi2b esp $xform2b $iv $esp_key
+		spi $gw2 $spi2c ah $xform2c $ah_key
+
+		spigrp $gw2 $spi2a \
+			$gw2 $spi2b \
+			$gw2 $spi2c
+		;;
+	turoad)
+		# return path
+		spi $gw1 $spi1b esp $xform1b $iv $esp_key
+		spi $gw1 $spi1c ah $xform1c $ah_key
+
+		route del $gw2
+		route add -host $gw2 dev ipsec0 gw $gw2a
+
+		# forward path
+		eroute add $net1 $nmask \
+			$gw2 $hmask \
+			$gw2 $spi2a
+
+		spi $gw2 $spi2a $xform2a \
+			$gw1 $gw2
+		spi $gw2 $spi2b esp $xform2b $iv $esp_key
+		spi $gw2 $spi2c ah $xform2c $ah_key
+
+		spigrp $gw2 $spi2a \
+			$gw2 $spi2b \
+			$gw2 $spi2c
+		;;
+	turoad2)
+		# return path
+		spi $gw1 $spi1b esp $xform1b $iv $esp_key
+		spi $gw1 $spi1c ah $xform1c $ah_key
+
+		route del $net2
+		route add -net $net2 dev ipsec0 gw $gw2
+
+		# forward path
+		eroute add $gw1 $hmask \
+			$net2 $nmask \
+			$gw2 $spi2a
+
+		spi $gw2 $spi2a $xform2a \
+			$gw1 $gw2
+		spi $gw2 $spi2b esp $xform2b $iv $esp_key
+		spi $gw2 $spi2c ah $xform2c $ah_key
+
+		spigrp $gw2 $spi2a \
+			$gw2 $spi2b \
+			$gw2 $spi2c
+		;;
+	tugw)
+		# return path
+		spi $gw1 $spi1b esp $xform1b $iv $esp_key
+		spi $gw1 $spi1c ah $xform1c $ah_key
+
+		route del $gw2
+		route add -host $gw2 dev ipsec0
+
+		# forward path
+		eroute add $gw1 $hmask \
+			$gw2 $hmask \
+			$gw2 $spi2a
+
+		spi $gw2 $spi2a $xform2a \
+			$gw1 $gw2
+		spi $gw2 $spi2b esp $xform2b $iv $esp_key
+		spi $gw2 $spi2c ah $xform2c $ah_key
+
+		spigrp $gw2 $spi2a \
+			$gw2 $spi2b \
+			$gw2 $spi2c
+		;;
+esac
+}
diff -bruN freeswan-1.9.orig/klips/utils/Makefile freeswan-1.9/klips/utils/Makefile
--- freeswan-1.9.orig/klips/utils/Makefile	Fri Jun 30 02:20:25 2000
+++ freeswan-1.9/klips/utils/Makefile	Mon Jun  4 11:34:31 2001
@@ -30,8 +30,8 @@
 CFLAGS+= -Wbad-function-cast 
 
 ALL=spi eroute spigrp tncfg klipsdebug
-BINDIR=/usr/local/lib/ipsec
-MANTREE=/usr/local/man
+BINDIR=/usr/lib/ipsec
+MANTREE=/usr/man
 MANDIR8=$(MANTREE)/man8
 MANDIR5=$(MANTREE)/man5
 FREESWANLIB=../../lib/libfreeswan.a
@@ -40,11 +40,11 @@
 all: $(ALL)
 
 install: $(ALL)
-	$(INSTALL) $(ALL) $(BINDIR)
+	$(INSTALL) $(ALL) $(PREFIX)/$(BINDIR)
 	for f in $(addsuffix .8, $(ALL)) ; do \
-		$(INSTALL) $$f $(MANDIR8)/ipsec_$$f || exit 1 ; done
+		$(INSTALL) $$f $(PREFIX)/$(MANDIR8)/ipsec_$$f || exit 1 ; done
 	for f in $(addsuffix .5, $(ALL) version pf_key) ; do \
-		$(INSTALL) $$f $(MANDIR5)/ipsec_$$f || exit 1 ; done
+		$(INSTALL) $$f $(PREFIX)/$(MANDIR5)/ipsec_$$f || exit 1 ; done
 
 spi: spi.o
 	$(CC) $(DFLAGS) -o $@ $? $(FREESWANLIB)
diff -bruN freeswan-1.9.orig/klips/utils/eroute.c freeswan-1.9/klips/utils/eroute.c
--- freeswan-1.9.orig/klips/utils/eroute.c	Sun Sep 17 14:56:48 2000
+++ freeswan-1.9/klips/utils/eroute.c	Mon Jun  4 12:56:04 2001
@@ -14,7 +14,7 @@
  * for more details.
  */
 
-char eroute_c_version[] = "RCSID $Id: eroute.c,v 1.38 2000/09/17 18:56:48 rgb Exp $";
+char eroute_c_version[] = "RCSID $Id: eroute.c,v 1.41 2001/05/21 02:02:54 rgb Exp $";
 
 
 #include <sys/types.h>
@@ -63,13 +63,14 @@
 usage(char* arg)
 {
 	fprintf(stdout, "usage: %s --{add,replace} --eraf <inet | inet6> --src <src>/<srcmaskbits>|<srcmask> --dst <dst>/<dstmaskbits>|<dstmask> <SA>\n", arg);
-	fprintf(stdout, "            where <SA> is '--af <inet | inet6> --edst <edst> --spi <spi> --proto <proto>' OR '--said <said>' OR '--said <%%passthrough | %%passthrough4 | %%passthrough6>'.\n");
+	fprintf(stdout, "            where <SA> is '--af <inet | inet6> --edst <edst> --spi <spi> --proto <proto>' OR '--said <said>' OR '--said <%%passthrough | %%passthrough4 | %%passthrough6 | %%drop | %%reject | %%trap | %%hold | %%pass>'.\n");
 	fprintf(stdout, "       %s --del --eraf <inet | inet6>--src <src>/<srcmaskbits>|<srcmask> --dst <dst>/<dstmaskbits>|<dstmask>\n", arg);
 	fprintf(stdout, "       %s --clear\n", arg);
 	fprintf(stdout, "       %s --help\n", arg);
 	fprintf(stdout, "       %s --version\n", arg);
 	fprintf(stdout, "       %s\n", arg);
 	fprintf(stdout, "        [ --debug ] is optional to any %s command.\n", arg);
+	fprintf(stdout, "        [ --label <label> ] is optional to any %s command.\n", arg);
 exit(1);
 }
 
@@ -122,20 +123,17 @@
  	int eroute_af = 0;
  	int said_af = 0;
 
-	if(argc == 1) {
-		system("cat /proc/net/ipsec_eroute");
-		exit(0);
-	}
+	int argcount = argc;
 
 	program_name = argv[0];
 	eroute_af_opt = said_af_opt = edst_opt = spi_opt = proto_opt = said_opt = dst_opt = src_opt = NULL;
 
-	while((c = getopt_long(argc, argv, "acdD:e:i:hprs:S:f:vl:+:g", longopts, 0)) != EOF)
-	{
+	while((c = getopt_long(argc, argv, ""/*"acdD:e:i:hprs:S:f:vl:+:g"*/, longopts, 0)) != EOF) {
 		switch(c) {
 		case 'g':
 			debug = 1;
 			pfkey_lib_debug = 1;
+			argcount--;
 			break;
 		case 'a':
 			if(action_type) {
@@ -210,9 +208,9 @@
 					program_name, optarg);
 				exit (1);
 			}
-			if(said.spi < 0x100) {
+			if(ntohl(said.spi) < 0x100) {
 				fprintf(stderr, "%s: Illegal reserved spi: %s => 0x%x Must be larger than 0x100.\n",
-					program_name, optarg, said.spi);
+					program_name, optarg, ntohl(said.spi));
 				exit(1);
 			}
 			spi_opt = optarg;
@@ -280,7 +278,7 @@
 				fprintf(stderr, "%s: Error, %s converting --sa argument:%s\n",
 					program_name, error_s, optarg);
 				exit (1);
-			} else if((said.spi < 0x100) && (said.spi > 0x0)){
+			} else if(ntohl(said.spi) < 0x100){
 				fprintf(stderr, "%s: Illegal reserved spi: %s => 0x%x Must be larger than or equal to 0x100.\n",
 					program_name, optarg, said.spi);
 				exit(1);
@@ -318,7 +316,13 @@
 			src_opt = optarg;
 			break;
 		case 'l':
-			program_name = optarg;
+			program_name = malloc(strlen(argv[0])
+					      + 10 /* update this when changing the sprintf() */
+					      + strlen(optarg));
+			sprintf(program_name, "%s --label %s",
+				argv[0],
+				optarg);
+			argcount -= 2;
 			break;
 		case 'i': /* specifies the address family of the SAID, stored in said_af */
 			if(said_af_opt) {
@@ -367,6 +371,11 @@
 		fprintf(stdout, "%s: DEBUG: argc=%d\n", program_name, argc);
 	}
 
+	if(argcount == 1) {
+		system("cat /proc/net/ipsec_eroute");
+		exit(0);
+	}
+
 	/* Sanity checks */
 
 	if(debug) {
@@ -699,6 +708,19 @@
 }
 /*
  * $Log: eroute.c,v $
+ * Revision 1.41  2001/05/21 02:02:54  rgb
+ * Eliminate 1-letter options.
+ *
+ * Revision 1.40  2001/05/16 04:39:57  rgb
+ * Fix --label option to add to command name rather than replace it.
+ * Fix 'print table' option to ignore --label and --debug options.
+ *
+ * Revision 1.39  2001/02/26 19:59:03  rgb
+ * Added a number of missing ntohl() conversions for debug output.
+ * Implement magic SAs %drop, %reject, %trap, %hold, %pass as part
+ * of the new SPD and to support opportunistic.
+ * Enforced spi > 0x100 requirement, now that pass uses a magic SA.
+ *
  * Revision 1.38  2000/09/17 18:56:48  rgb
  * Added IPCOMP support.
  *
diff -bruN freeswan-1.9.orig/klips/utils/klipsdebug.c freeswan-1.9/klips/utils/klipsdebug.c
--- freeswan-1.9.orig/klips/utils/klipsdebug.c	Tue Oct 10 23:56:54 2000
+++ freeswan-1.9/klips/utils/klipsdebug.c	Mon Jun  4 12:54:13 2001
@@ -14,7 +14,7 @@
  * for more details.
  */
 
-char klipsdebug_c_version[] = "RCSID $Id: klipsdebug.c,v 1.38 2000/10/11 03:56:54 rgb Exp $";
+char klipsdebug_c_version[] = "RCSID $Id: klipsdebug.c,v 1.40 2001/05/21 02:02:54 rgb Exp $";
 
 
 #include <sys/types.h>
@@ -84,6 +84,7 @@
 	fprintf(stdout, "       %s --version\n", arg);
 	fprintf(stdout, "       %s\n", arg);
 	fprintf(stdout, "        [ --debug ] is optional to any %s command\n", arg);
+	fprintf(stdout, "        [ --label <label> ] is optional to any %s command.\n", arg);
 	exit(1);
 }
 
@@ -113,24 +114,21 @@
 	struct encap_msghdr *em = (struct encap_msghdr *)bigbuf;
 	int debug = 0;
 	int error = 0;
+	int argcount = argc;
 
 	struct sadb_ext *extensions[SADB_EXT_MAX + 1];
 	struct sadb_msg *pfkey_msg;
 	
 	bitfieldp = (int *)&em->em_db_tn;
 
-	if(argc == 1) {
-		system("cat /proc/net/ipsec_klipsdebug");
-		exit(0);
-	}
-
 	program_name = argv[0];
 
-	while((c = getopt_long(argc, argv, "s:c:anhvl:+:d", longopts, 0)) != EOF) {
+	while((c = getopt_long(argc, argv, ""/*"s:c:anhvl:+:d"*/, longopts, 0)) != EOF) {
 		switch(c) {
 		case 'd':
 			debug = 1;
 			pfkey_lib_debug = 1;
+			argcount--;
 			break;
 		case 's':
 			if(action) {
@@ -247,7 +245,13 @@
 			fputs(copyright, stdout);
 			exit(0);
 		case 'l':
-			program_name = optarg;
+			program_name = malloc(strlen(argv[0])
+					      + 10 /* update this when changing the sprintf() */
+					      + strlen(optarg));
+			sprintf(program_name, "%s --label %s",
+				argv[0],
+				optarg);
+			argcount -= 2;
 			break;
 		case '+': /* optionsfrom */
 			optionsfrom(optarg, &argc, &argv, optind, stderr);
@@ -258,6 +262,11 @@
 		previous = c;
 	}
 
+	if(argcount == 1) {
+		system("cat /proc/net/ipsec_klipsdebug");
+		exit(0);
+	}
+
  	em->em_magic = EM_MAGIC;
 	em->em_version = 0;
 	if(action) {
@@ -418,6 +427,15 @@
 }
 /*
  * $Log: klipsdebug.c,v $
+ * Revision 1.40  2001/05/21 02:02:54  rgb
+ * Eliminate 1-letter options.
+ *
+ * Revision 1.39  2001/05/16 05:07:19  rgb
+ * Fixed --label option in KLIPS manual utils to add the label to the
+ * command name rather than replace it in error text.
+ * Fix 'print table' non-option in KLIPS manual utils to deal with --label
+ * and --debug options.
+ *
  * Revision 1.38  2000/10/11 03:56:54  rgb
  * Initialise verbose field to zero on --all.
  *
diff -bruN freeswan-1.9.orig/klips/utils/spi.c freeswan-1.9/klips/utils/spi.c
--- freeswan-1.9.orig/klips/utils/spi.c	Sun Nov  5 23:36:57 2000
+++ freeswan-1.9/klips/utils/spi.c	Mon Jun  4 12:54:13 2001
@@ -14,7 +14,7 @@
  * for more details.
  */
 
-char spi_c_version[] = "RCSID $Id: spi.c,v 1.70 2000/11/06 04:36:57 rgb Exp $";
+char spi_c_version[] = "RCSID $Id: spi.c,v 1.73 2001/05/30 08:14:05 rgb Exp $";
 
 #include <asm/types.h>
 #include <sys/types.h>
@@ -99,7 +99,8 @@
 	where <algo> is:	3des\n\
 spi --comp <algo> <SA>\n\
 	where <algo> is:	deflate\n\
-[ --debug ] is optional to any spi command.
+[ --debug ] is optional to any spi command.\n\
+[ --label <label> ] is optional to any spi command.
 ";
 
 
@@ -315,6 +316,7 @@
 	char ipsaid_txt[SATOT_BUF];
 
 	int error = 0;
+	int argcount = argc;
 
 	unsigned char authalg, encryptalg;
 	struct sadb_ext *extensions[SADB_EXT_MAX + 1];
@@ -325,18 +327,26 @@
 	ip_address pfkey_ident_d_ska;
 #endif
 	
-	if(argc == 1) {
-		system("cat /proc/net/ipsec_spi");
-		exit(0);
-	}
-
 	program_name = argv[0];
 	memset(&said, 0, sizeof(said));
 	iv_opt = akey_opt = ekey_opt = alg_opt = edst_opt = spi_opt = proto_opt = af_opt = said_opt = dst_opt = src_opt = NULL;
 	
-	while((c = getopt_long(argc, argv, "H:P:Z:46dcA:E:e:s:a:w:i:D:S:hvgl:+:", longopts, 0)) != EOF)
-	{
+	while((c = getopt_long(argc, argv, ""/*"H:P:Z:46dcA:E:e:s:a:w:i:D:S:hvgl:+:"*/, longopts, 0)) != EOF) {
 		switch(c) {
+		case 'g':
+			debug = 1;
+			pfkey_lib_debug = 1;
+			argcount--;
+			break;
+		case 'l':
+			program_name = malloc(strlen(argv[0])
+					      + 10 /* update this when changing the sprintf() */
+					      + strlen(optarg));
+			sprintf(program_name, "%s --label %s",
+				argv[0],
+				optarg);
+			argcount -= 2;
+			break;
 		case 'H':
 			if(alg) {
 				fprintf(stderr, "%s: Only one of '--ah', '--esp', '--comp', '--ip4', '--ip6', '--del' or '--clear'  options permitted.\n",
@@ -365,10 +375,6 @@
 			}
 			if       (!strcmp(optarg, "3des-md5-96")) {
 				alg = XF_ESP3DESMD596;
-			} else if(!strcmp(optarg, "null-md5-96")) {
-				alg = XF_ESPNULLMD596;
-			} else if(!strcmp(optarg, "null-sha1-96")) {
-				alg = XF_ESPNULLSHA196;
 			} else if(!strcmp(optarg, "3des-sha1-96")) {
 				alg = XF_ESP3DESSHA196;
 			} else if(!strcmp(optarg, "3des")) {
@@ -742,13 +748,6 @@
 		case 'v':
 			fprintf(stdout, "%s, %s\n", program_name, spi_c_version);
 			exit(1);
-		case 'l':
-			program_name = optarg;
-			break;
-		case 'g':
-			debug = 1;
-			pfkey_lib_debug = 1;
-			break;
 		case '+': /* optionsfrom */
 			optionsfrom(optarg, &argc, &argv, optind, stderr);
 			/* no return on error */
@@ -760,6 +759,12 @@
 	if(debug) {
 		fprintf(stdout, "All options processed.\n");
 	}
+
+	if(argcount == 1) {
+		system("cat /proc/net/ipsec_spi");
+		exit(0);
+	}
+
 	switch(alg) {
 	case XF_IP4:
 	case XF_IP6:
@@ -768,8 +773,6 @@
 	case XF_AHHMACSHA1:
 	case XF_ESP3DESMD596:
 	case XF_ESP3DESSHA196:
-	case XF_ESPNULLMD596:
-	case XF_ESPNULLSHA196:
 	case XF_ESP3DES:
 	case XF_COMPDEFLATE:
 		if(!said_opt) {
@@ -822,8 +825,6 @@
 	case XF_AHHMACSHA1:
 	case XF_ESP3DESMD596:
 	case XF_ESP3DESSHA196:
-	case XF_ESPNULLMD596:
-	case XF_ESPNULLSHA196:
 	case XF_ESP3DES:
 	case XF_COMPDEFLATE:
 		break;
@@ -1068,12 +1069,10 @@
 	switch(alg) {
 	case XF_AHHMACMD5:
 	case XF_ESP3DESMD596:
-	case XF_ESPNULLMD596:
 		authalg = SADB_AALG_MD5HMAC;
 		break;
 	case XF_AHHMACSHA1:
 	case XF_ESP3DESSHA196:
-	case XF_ESPNULLSHA196:
 		authalg = SADB_AALG_SHA1HMAC;
 		break;
 	case XF_ESP3DESMD5:
@@ -1086,10 +1085,6 @@
 	case XF_ESP3DESSHA196:
 		encryptalg = SADB_EALG_3DESCBC;
 		break;
-	case XF_ESPNULLMD596:
-	case XF_ESPNULLSHA196:
-		encryptalg = SADB_EALG_NULL;
-		break;
 	case XF_COMPDEFLATE:
 		encryptalg = SADB_X_CALG_DEFLATE;
 		break;
@@ -1255,10 +1250,8 @@
 		switch(alg) {
 		case XF_AHHMACMD5:
 		case XF_ESP3DESMD596:
-		case XF_ESPNULLMD596:
 		case XF_AHHMACSHA1:
 		case XF_ESP3DESSHA196:
-		case XF_ESPNULLSHA196:
 			if((error = pfkey_key_build(&extensions[SADB_EXT_KEY_AUTH],
 						    SADB_EXT_KEY_AUTH,
 						    authkeylen * 8,
@@ -1479,6 +1472,18 @@
 
 /*
  * $Log: spi.c,v $
+ * Revision 1.73  2001/05/30 08:14:05  rgb
+ * Removed vestiges of esp-null transforms.
+ *
+ * Revision 1.72  2001/05/21 02:02:55  rgb
+ * Eliminate 1-letter options.
+ *
+ * Revision 1.71  2001/05/16 05:07:20  rgb
+ * Fixed --label option in KLIPS manual utils to add the label to the
+ * command name rather than replace it in error text.
+ * Fix 'print table' non-option in KLIPS manual utils to deal with --label
+ * and --debug options.
+ *
  * Revision 1.70  2000/11/06 04:36:57  rgb
  * Display conversion on replay_window failure.
  * Don't register SATYPEs for manual.
diff -bruN freeswan-1.9.orig/klips/utils/spigrp.c freeswan-1.9/klips/utils/spigrp.c
--- freeswan-1.9.orig/klips/utils/spigrp.c	Tue Jan 23 15:24:12 2001
+++ freeswan-1.9/klips/utils/spigrp.c	Mon Jun  4 12:54:13 2001
@@ -14,7 +14,7 @@
  * for more details.
  */
 
-char spigrp_c_version[] = "RCSID $Id: spigrp.c,v 1.36 2001/01/23 20:24:12 rgb Exp $";
+char spigrp_c_version[] = "RCSID $Id: spigrp.c,v 1.37 2001/05/16 05:07:20 rgb Exp $";
 
 
 #include <sys/types.h>
@@ -72,6 +72,8 @@
 	fprintf(stdout, "usage: %s --help\n", s);
 	fprintf(stdout, "usage: %s --version\n", s);
 	fprintf(stdout, "usage: %s\n", s);
+	fprintf(stdout, "        [ --debug ] is optional to any %s command.\n", s);
+	fprintf(stdout, "        [ --label <label> ] is optional to any %s command.\n", s);
 }
 
 	
@@ -119,7 +121,12 @@
 
         if(argc > 1 && strcmp(argv[1], "--label") == 0) {
 		if(argc > 2) {
-			program_name = argv[2];
+			program_name = malloc(strlen(argv[0])
+					      + 10 /* update this when changing the sprintf() */
+					      + strlen(argv[2]));
+			sprintf(program_name, "%s --label %s",
+				argv[0],
+				argv[2]);
 			if(debug) {
 				fprintf(stdout, "using \"%s\" as a label.\n", program_name);
 			}
@@ -475,6 +482,12 @@
 }
 /*
  * $Log: spigrp.c,v $
+ * Revision 1.37  2001/05/16 05:07:20  rgb
+ * Fixed --label option in KLIPS manual utils to add the label to the
+ * command name rather than replace it in error text.
+ * Fix 'print table' non-option in KLIPS manual utils to deal with --label
+ * and --debug options.
+ *
  * Revision 1.36  2001/01/23 20:24:12  rgb
  * Fix comment to reflect reality that src is not needed for grouping.
  *
diff -bruN freeswan-1.9.orig/klips/utils/tncfg.c freeswan-1.9/klips/utils/tncfg.c
--- freeswan-1.9.orig/klips/utils/tncfg.c	Tue Sep 12 09:09:05 2000
+++ freeswan-1.9/klips/utils/tncfg.c	Mon Jun  4 12:54:13 2001
@@ -14,7 +14,7 @@
  * for more details.
  */
 
-char tncfg_c_version[] = "RCSID $Id: tncfg.c,v 1.24 2000/09/12 13:09:05 rgb Exp $";
+char tncfg_c_version[] = "RCSID $Id: tncfg.c,v 1.26 2001/05/21 02:02:55 rgb Exp $";
 
 
 #include <stdio.h>
@@ -55,6 +55,8 @@
 		name);
 	fprintf(stdout,"%s\n",
 		name);
+	fprintf(stdout, "        [ --debug ] is optional to any %s command.\n", name);
+	fprintf(stdout, "        [ --label <label> ] is optional to any %s command.\n", name);
 	exit(1);
 }
 
@@ -82,19 +84,16 @@
 	int c, previous = -1;
 	char *program_name;
 	int debug = 0;
-     
-	if(argc == 1) {
-		system("cat /proc/net/ipsec_tncfg");
-		exit(0);
-	}
+	int argcount = argc;
 
 	memset(&ifr, 0, sizeof(ifr));
 	program_name = argv[0];
 
-	while((c = getopt_long_only(argc, argv, "adchvV:P:l:+:", longopts, 0)) != EOF) {
+	while((c = getopt_long_only(argc, argv, ""/*"adchvV:P:l:+:"*/, longopts, 0)) != EOF) {
 		switch(c) {
 		case 'g':
 			debug = 1;
+			argcount--;
 			break;
 		case 'a':
 			if(shc->cf_cmd) {
@@ -135,7 +134,13 @@
 			strcpy(shc->cf_name, optarg);
 			break;
 		case 'l':
-			program_name = optarg;
+			program_name = malloc(strlen(argv[0])
+					      + 10 /* update this when changing the sprintf() */
+					      + strlen(optarg));
+			sprintf(program_name, "%s --label %s",
+				argv[0],
+				optarg);
+			argcount -= 2;
 			break;
 		case '+': /* optionsfrom */
 			optionsfrom(optarg, &argc, &argv, optind, stderr);
@@ -148,6 +153,11 @@
 		previous = c;
 	}
 
+	if(argcount == 1) {
+		system("cat /proc/net/ipsec_tncfg");
+		exit(0);
+	}
+
 	switch(shc->cf_cmd) {
 	case IPSEC_SET_DEV:
 		if(!shc->cf_name) {
@@ -263,6 +273,15 @@
 	
 /*
  * $Log: tncfg.c,v $
+ * Revision 1.26  2001/05/21 02:02:55  rgb
+ * Eliminate 1-letter options.
+ *
+ * Revision 1.25  2001/05/16 05:07:20  rgb
+ * Fixed --label option in KLIPS manual utils to add the label to the
+ * command name rather than replace it in error text.
+ * Fix 'print table' non-option in KLIPS manual utils to deal with --label
+ * and --debug options.
+ *
  * Revision 1.24  2000/09/12 13:09:05  rgb
  * Fixed real/physical discrepancy between tncfg.8 and tncfg.c.
  *
diff -bruN freeswan-1.9.orig/klips/utils/version.c freeswan-1.9/klips/utils/version.c
--- freeswan-1.9.orig/klips/utils/version.c	Mon Feb 26 18:56:08 2001
+++ freeswan-1.9/klips/utils/version.c	Thu Jun  7 14:53:56 2001
@@ -1,2 +1,2 @@
-/* silly pointless RCSID $Id: version.c,v 1.17.2.1 2001/02/26 23:56:08 henry Exp $ */
-static const char freeswan_version[] = "1.9";
+/* silly pointless RCSID $Id: version.c,v 1.19 2001/05/30 13:02:20 henry Exp $ */
+static const char freeswan_version[] = "FreeSWAN-1.9-pkix2";
diff -bruN freeswan-1.9.orig/lib/Makefile freeswan-1.9/lib/Makefile
--- freeswan-1.9.orig/lib/Makefile	Wed Oct 25 19:58:57 2000
+++ freeswan-1.9/lib/Makefile	Wed May 16 10:57:20 2001
@@ -1,5 +1,3 @@
-# FreeS/WAN library
-# Copyright (C) 1998, 1999  Henry Spencer.
 # 
 # This program is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by the
@@ -57,11 +55,11 @@
 all:	$(EXTHDRS) $(LIB) $(EXTLIBS)
 
 install:
-	mkdir -p $(MANDIR)
+	mkdir -p $(PREFIX)/$(MANDIR)
 	for f in $(MANS) ; \
 	do \
-		$(INSTALL) $$f $(MANDIR)/ipsec_$$f || exit 1 ; \
-		../utils/manlink $(MANDIR) ipsec_$$f ; \
+		$(INSTALL) $$f $(PREFIX)/$(MANDIR)/ipsec_$$f || exit 1 ; \
+		../utils/manlink $(PREFIX)/$(MANDIR) ipsec_$$f ; \
 	done
 
 $(LIB):	$(OBJS)
diff -bruN freeswan-1.9.orig/lib/freeswan.h freeswan-1.9/lib/freeswan.h
--- freeswan-1.9.orig/lib/freeswan.h	Tue Jan 23 15:25:37 2001
+++ freeswan-1.9/lib/freeswan.h	Wed May 16 10:57:20 2001
@@ -13,7 +13,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public
  * License for more details.
  *
- * RCSID $Id: freeswan.h,v 1.46 2001/01/23 20:25:37 rgb Exp $
+ * RCSID $Id: freeswan.h,v 1.51 2001/05/03 19:44:40 rgb Exp $
  */
 #define	_FREESWAN_H	/* seen it, no need to see it again */
 
@@ -70,6 +70,12 @@
 #define IP_SELECT_IDENT
 #endif
 
+#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,4,4)
+#define IP_SELECT_IDENT_NEW
+#define IPH_is_SKB_PULLED
+#define SKB_COW_NEW
+#endif
+
 #if (LINUX_VERSION_CODE >= KERNEL_VERSION(2,3,50)) && defined(CONFIG_NETFILTER)
 #define SKB_RESET_NFCT
 #endif
@@ -155,6 +161,10 @@
 #define IPPROTO_COMP 108
 #endif /* !IPPROTO_COMP */
 
+#ifndef IPPROTO_INT
+#define IPPROTO_INT 61
+#endif /* !IPPROTO_INT */
+
 #ifdef CONFIG_IPSEC_DEBUG
 #define DEBUG_NO_STATIC
 #else /* CONFIG_IPSEC_DEBUG */
@@ -221,11 +231,17 @@
 typedef struct {		/* to identify an SA, we need: */
         ip_address dst;		/* A. destination host */
         ipsec_spi_t spi;	/* B. 32-bit SPI, assigned by dest. host */
+#		define	SPI_PASS	256	/* magic values... */
+#		define	SPI_DROP	257	/* ...for use... */
+#		define	SPI_REJECT	258	/* ...with SA_INT */
+#		define	SPI_HOLD	259
+#		define	SPI_TRAP	260
 	int proto;		/* C. protocol */
 #		define	SA_ESP	50	/* IPPROTO_ESP */
 #		define	SA_AH	51	/* IPPROTO_AH */
 #		define	SA_IPIP	4	/* IPPROTO_IPIP */
 #		define	SA_COMP	108	/* IPPROTO_COMP */
+#		define	SA_INT	61	/* IANA reserved for internal use */
 } ip_said;
 struct sa_id {			/* old v4-only version */
         struct in_addr dst;
diff -bruN freeswan-1.9.orig/lib/pfkey.h freeswan-1.9/lib/pfkey.h
--- freeswan-1.9.orig/lib/pfkey.h	Tue Oct 10 16:10:19 2000
+++ freeswan-1.9/lib/pfkey.h	Wed May 16 10:57:20 2001
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: pfkey.h,v 1.28 2000/10/10 20:10:19 rgb Exp $
+ * RCSID $Id: pfkey.h,v 1.30 2001/02/27 07:04:52 rgb Exp $
  */
 
 #ifndef __NET_IPSEC_PF_KEY_H
@@ -55,8 +55,6 @@
 extern int pfkey_list_insert_supported(struct supported*, struct supported_list**);
 extern int pfkey_list_remove_supported(struct supported*, struct supported_list**);
 
-extern uint8_t sadb_satype2proto[];
-
 /*
 #if defined(__KERNEL__) || !defined(__GLIBC__) || (__GLIBC__ < 2)
  */
@@ -84,6 +82,7 @@
 
 extern uint8_t satype2proto(uint8_t satype);
 extern uint8_t proto2satype(uint8_t proto);
+extern char* satype2name(uint8_t satype);
 extern char* proto2name(uint8_t proto);
 
 struct key_opt
@@ -231,6 +230,12 @@
 
 /*
  * $Log: pfkey.h,v $
+ * Revision 1.30  2001/02/27 07:04:52  rgb
+ * Added satype2name prototype.
+ *
+ * Revision 1.29  2001/02/26 19:59:33  rgb
+ * Ditch unused sadb_satype2proto[], replaced by satype2proto().
+ *
  * Revision 1.28  2000/10/10 20:10:19  rgb
  * Added support for debug_ipcomp and debug_verbose to klipsdebug.
  *
